SUB Fade12(PaletteVals%(), Index%) PUBLIC

  ' make a copy of the original palette and find high value
  DIM DYNAMIC Original%(0:15)
  FOR c% = Index% TO (Index% + 15)
    Original%(c% - Index%) = PaletteVals%(c%)
    IF PaletteVals%(c%) > HighValue% THEN HighValue% = PaletteVals%(c%)
  NEXT c%

  ' now fade the colors, one step at a time
  FOR c% = HighValue% TO 0 STEP -1
    ' decrement all color values >0
    FOR d% = 0 TO 15
      IF Original%(d%) THEN DECR Original%(d%)
    NEXT d%
    ' update the palette all at once
    PALETTE USING Original%(0)
  NEXT c%

END SUB

' test code
SCREEN 12	' VGA 640x480x16 mode
DIM PaletteVals%(0:15)
FOR c% = 0 TO 15		' show boxes in each color
  x% = ((c% MOD 4) * 100) + 50	' get coordinates for each box
  y% = ((c% \ 4) * 100) + 50
  LINE (x%, y%) - (x% + 50, y% + 50), c%, BF	' draw a box
  PaletteVals%(c%) = c%		' store the default color values
NEXT c%
WHILE LEN(INKEY$) = 0 : WEND	' wait for a keystroke
' now fade the screen
CALL Fade12(PaletteVals%(), 0)
WHILE LEN(INKEY$) = 0 : WEND	' wait for a keystroke
' restore the default palette (which "redisplays" the boxes)
PALETTE
END
