SCREEN 12	' VGA 640x480x16 mode

' change the palette to black (for all attributes)
DIM Pal%(0:15)	' defaults to 0 for all elements
PALETTE USING Pal%(0)

' now display boxes on the screen using the different attributes
FOR c% = 0 TO 15		' show boxes in each color
  x% = ((c% MOD 4) * 100) + 50	' get coordinates for each box
  y% = ((c% \ 4) * 100) + 50
  LINE (x%, y%) - (x% + 50, y% + 50), c%, BF	' draw a box
  Pal%(c%) = c%			' set new palette values
NEXT c%

' restore the palette to "pop" the boxes onto the screen
PALETTE USING Pal%(0)

WHILE LEN(INKEY$) = 0 : WEND	' wait for a keystroke
' restore the default palette
PALETTE
END
