' Show all 64 colors in mode 12.
SCREEN 12

' this array contains the available palette colors
DIM Pal%(0:64)
FOR c% = 1 TO 64	' populate the array
  Pal%(c%) = c%
NEXT c%

' set the palette for the first 8 colors
PALETTE USING Pal%(0)

' display 8 boxes on the screen
FOR c% = 1 TO 8
  x% = (((c% - 1) MOD 4) * 100) + 100
  y% = (((c% - 1) \ 4) * 150) + 100
  LINE (x%, y%) - (x% + 75, y% + 50), c%, BF
NEXT c%

' display the color values and cycle through the colors
FOR c% = 1 TO 8
  FOR d% = 1 TO 8
    IF c% = 8 THEN COLOR 7	' change color of text on last screen
    LOCATE (((d% - 1) \ 4) * 9) + 6, (((d% - 1) MOD 4) * 12) + 17
    PRINT ((c% - 1) * 8) + d%
  NEXT d%
  WHILE LEN(INKEY$) = 0 : WEND	' wait for a keystroke
  ' change the palette and redisplay the numbers
  IF c% < 8 THEN	' don't change the palette if this is the last screen
    Pal%(c% * 8) = 0	' reset new bottom color to 0 (black)
    PALETTE USING Pal%(c% * 8)
  END IF
NEXT c%
