$COMPILE DLL
$DIM ALL

DEFINT A-Z

' This code is placed in the public domain, March 8th, 1997.

$INCLUDE "WINAPI.INC"
DECLARE FUNCTION EnumWindows LIB "USER" (BYVAL lpEnumFunc AS DWORD, BYVAL lParam AS DWORD)
AS INTEGER

TYPE EnumerType
  nCount  AS INTEGER
  fHandle AS INTEGER
END TYPE

%TitleSize = 40
%MaxNCount = 30

GLOBAL answer AS INTEGER
GLOBAL enumer AS EnumerType
GLOBAL enumList() AS ASCIIZ * %TitleSize
GLOBAL ghInstance AS INTEGER
GLOBAL lpsText AS ASCIIZ * 128
GLOBAL lpsCaption AS ASCIIZ * 128

DECLARE FUNCTION WndEnumProc(BYVAL hWnd AS WORD, BYVAL enumPtr AS DWORD) AS INTEGER

FUNCTION LibMain(BYVAL hInstance AS INTEGER, BYVAL wDataSeg AS WORD, BYVAL wHeapSize AS
WORD, lpszCmdLine AS ASCIIZ PTR) EXPORT AS INTEGER

  REDIM enumList(1 TO %MaxNCount) AS ASCIIZ * %TitleSize
  ghInstance = hInstance
  LibMain = 1

END FUNCTION


' WndEnumFunc - Enumeration call back function

FUNCTION WndEnumFunc(BYVAL hWindow AS WORD, BYVAL enumPtr AS DWORD)
EXPORT AS INTEGER

  DIM enumer AS LOCAL EnumerType PTR
  DIM lpWindName AS LOCAL ASCIIZ PTR
  DIM wBuf AS LOCAL ASCIIZ * %TitleSize
  DIM wHandle AS INTEGER

  enumer  = enumPtr
  wHandle = @enumer.fHandle

  GetWindowText hWindow, wBuf, %TitleSize

  IF @enumer.nCount < %MaxNCount THEN
    INCR @enumer.nCount
    enumList(@enumer.nCount) = wBuf
    WndEnumFunc = 1
  ELSE
    WndEnumFunc = 0
  END IF

END FUNCTION


' WndEnumOccurrences - CALLable Enumeration routine

FUNCTION WndEnumOccurrences(titleToCheck AS ASCIIZ PTR) EXPORT AS INTEGER

  DIM lpfEnumProc AS LOCAL DWORD
  DIM ndx AS LOCAL INTEGER
  DIM retVal AS LOCAL INTEGER
  DIM wTitle AS LOCAL ASCIIZ * %TitleSize

  ' Create
  lpfEnumProc = MakeProcInstance(CODEPTR(WndEnumFunc), ghInstance)

  ' Process
  enumer.nCount = 0
  wTitle = UCASE$(@titleToCheck)

  EnumWindows lpfEnumProc, VARPTR(enumer)

  retVal = 0
  FOR ndx = 1 TO enumer.nCount
    wTitle = UCASE$(enumList(ndx))
    IF LEFT$(wTitle, LEN(@titleToCheck)) = UCASE$(@titleToCheck) THEN
      INCR retVal
    END IF
  NEXT ndx

  ' Clean up
  FreeProcInstance lpfEnumProc

  ' Return value to caller
  WndEnumOccurrences = retVal

END FUNCTION


' WndEnumTasks - CALLable Enumeration routine

SUB WndEnumTasks() EXPORT

  DIM lpfEnumProc AS LOCAL DWORD
  DIM lpWindNames AS LOCAL ASCIIZ PTR
  DIM fName AS LOCAL STRING
  DIM ndx AS LOCAL INTEGER
  DIM wBuf AS LOCAL STRING

  ' Create
  lpfEnumProc = MakeProcInstance(CODEPTR(WndEnumFunc), ghInstance)

  ' Process
  enumer.fHandle = FREEFILE
  enumer.nCount = 0
  fName = "C:\ENUM.LST"
  OPEN fName FOR OUTPUT AS #enumer.fHandle

  wBuf = "Function Instance handle is " + STR$(lpfEnumProc)
  PRINT #enumer.fHandle, wBuf

  EnumWindows lpfEnumProc, VARPTR(enumer)

  wBuf = "Number of entries is " + STR$(enumer.nCount)
  PRINT #enumer.fHandle, wBuf

  FOR ndx = 1 TO enumer.nCount
    PRINT #enumer.fHandle, enumList(ndx)
  NEXT ndx

  CLOSE #enumer.fHandle

  ' Clean up
  FreeProcInstance lpfEnumProc

END SUB
